#include <iostream>
#include <cmath>

// Achtung: eigentlich nicht streng monoton!
double f(double x)
{
	return sin(x);
}

double nullstelle(double a, double b) {
	double const eps = 1.0e-10;
	double fa = f(a), fb = f(b); 
	double c = (a + b) / 2., fc = f(c);
	if (fabs(fa - fb) < eps) return c;
	return (fa < 0 && fc < 0 || fa > 0 && fc > 0) ?
		nullstelle(c, b) : nullstelle(a, c);
}

int main()
{
	std::cout << nullstelle(2.0, 4.0) << std::endl;
}
